﻿##!/usr/bin/env python

# This file is a part of plugin "export LaTeX" for NoteCalc.
# "export LaTeX" is a plugin under GNU GPL

import os,gtk,ConfigParser

#debugging
import pdb

class options :

    def __init__ (self):

        print ("*** options ***")

        import gtk.glade
        #pdb.set_trace()

        self.gui = gtk.glade.XML(os.path.join(os.path.dirname(__file__),"options.glade"))
        dictionnaire_temporaire = {}
        for iteration in dir(self.__class__):
            dictionnaire_temporaire[iteration]= getattr(self,iteration)
        self.gui.signal_autoconnect(dictionnaire_temporaire)

        fileconfig = os.path.join(os.environ['NOTECALC_CONFPLUGINSDIR'],'export_latex.cfg')
        if not os.path.exists(fileconfig) :
            if os.name=='nt' :
                dialogmsg = _("Le plugin \"export_LaTeX\" permet de compiler à la volé les sources tex (très pratique si vous ne connaissez pas LaTeX) mais pour cella il faut qu'un compilateur tel que MiKTeX (www.miktex.org/) soit installé sur votre machine.")
                rundialogbox = True
            else :
                outsys = os.system("latex -v")
                if outsys != 0 :
                    dialogmsg = _("Le plugin \"export_LaTeX\" permet de compiler à la volée les sources tex (très pratique si vous ne connaissez pas LaTeX) mais pour cella il vous faut installez les paquets \"texlive\" et \"texlive-lang-<lang>\".")
                    rundialogbox = True
                else :
                    rundialogbox = False
            if rundialogbox :
                dialog = gtk.MessageDialog(
                        self.gui.get_widget('optionsLaTeX'), #parent
                        gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                        gtk.MESSAGE_INFO, # type
                        gtk.BUTTONS_OK, # boutons
                        dialogmsg #Message
                    )
                dialog.run()
                dialog.destroy()

        config = ConfigParser.ConfigParser()
        config.read(os.path.join(fileconfig))

        try :
            self.gui.get_widget('type').set_text(config.get('Option exportLaTeX', 'type'))
        except :
            self.gui.get_widget('type').set_text('Article')

        try :
            self.gui.get_widget('format').set_text(config.get('Option exportLaTeX', 'format'))
        except :
            self.gui.get_widget('format').set_text('A4paper')

        try :
            self.gui.get_widget('policeSize').set_text(config.get('Option exportLaTeX', 'policeSize'))
        except :
            self.gui.get_widget('policeSize').set_text('12')

        try :
            self.gui.get_widget('lang').set_text(config.get('Option exportLaTeX', 'lang'))
        except :
            import locale
            lang = locale.getdefaultlocale()[0][:2]
            if lang == 'fr':
                self.gui.get_widget('lang').set_text('french')
            elif lang == 'en':
                self.gui.get_widget('lang').set_text('english')
            else:
                self.gui.get_widget('lang').set_text(_('Indiquez le nom de votre langue en anglais'))

        try :
            self.gui.get_widget('compilator').set_text(config.get('Option exportLaTeX', 'compilator'))
        except :
            if os.name == 'nt':
                self.gui.get_widget('compilator').set_text('"%s"'%os.path.join(os.environ['PROGRAMFILES'],'MiKTeX 2.7','miktex','bin','latex.exe'))
            else :
                self.gui.get_widget('compilator').set_text('latex')

        try :
            self.gui.get_widget('tablematiere').set_active(config.getint('Option exportLaTeX', 'tablematiere'))
        except :
            self.gui.get_widget('tablematiere').set_active(1)

        try :
            self.gui.get_widget('titlepage').set_active(config.getint('Option exportLaTeX', 'titlepage'))
        except :
            self.gui.get_widget('titlepage').set_active(0)

        try :
            self.gui.get_widget('twocolum').set_active(config.getint('Option exportLaTeX', 'twocolum'))
        except :
            self.gui.get_widget('twocolum').set_active(0)

        try :
            self.gui.get_widget('twoside').set_active(config.getint('Option exportLaTeX', 'twoside'))
        except :
            self.gui.get_widget('twoside').set_active(0)

        try :
            self.gui.get_widget('landscape').set_active(config.getint('Option exportLaTeX', 'landscape'))
        except :
            self.gui.get_widget('landscape').set_active(0)


        #return True


    def on_validButton_clicked(self,button):
        '''Quand ok est clicker, enregistrement dans un fichier ini'''
        print "valider"

        config = ConfigParser.ConfigParser()

        config.add_section('Option exportLaTeX')
        config.set('Option exportLaTeX', 'type', self.gui.get_widget("type").get_text())
        config.set('Option exportLaTeX', 'format', self.gui.get_widget("format").get_text())
        config.set('Option exportLaTeX', 'policeSize', self.gui.get_widget("policeSize").get_text())
        config.set('Option exportLaTeX', 'lang', self.gui.get_widget("lang").get_text())
        config.set('Option exportLaTeX', 'compilator', self.gui.get_widget("compilator").get_text())

        config.set('Option exportLaTeX', 'tablematiere',int(self.gui.get_widget("tablematiere").get_active()))
        config.set('Option exportLaTeX', 'titlepage',int(self.gui.get_widget("titlepage").get_active()))
        config.set('Option exportLaTeX', 'twocolum', int(self.gui.get_widget("twocolum").get_active()))
        config.set('Option exportLaTeX', 'twoside',int(self.gui.get_widget("twoside").get_active()))
        config.set('Option exportLaTeX', 'landscape', int(self.gui.get_widget("landscape").get_active()))

        config.write(open(os.path.join(os.environ['NOTECALC_CONFPLUGINSDIR'],'export_latex.cfg'),'w'))

        self.gui.get_widget('optionsLaTeX').destroy()


    def on_cancelButton_clicked(self,button):
        '''bt_cancel'''
        print "fermer"
        self.gui.get_widget('optionsLaTeX').destroy()


    def on_helpButton_clicked(self,button):
        '''bt_help'''
        from webbrowser import open
        open ("http://jonas.tuxfamily.org/wiki/notecalc/plugins/export_latex")
        print "aide"


    def on_browseButton_clicked(self,button):
        '''bt_browse'''
        print "browse"
        chooser = gtk.FileChooserDialog(
                    title="Compilateur LaTeX",
                    parent=None,
                    action=gtk.FILE_CHOOSER_ACTION_OPEN,
                    buttons= (
                            gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                            gtk.STOCK_OK, gtk.RESPONSE_OK
                        ),
                    backend=None
                )

        if (chooser.run() == gtk.RESPONSE_OK):
            self.gui.get_widget('compilator').set_text('"%s"'%chooser.get_filename())
        chooser.destroy()



if __name__ == "__main__":
    os.environ['NOTECALC_CONFPLUGINSDIR'] = os.path.dirname(__file__)

options = options()
gtk.main()




