﻿##!/usr/bin/env python

import os, ConfigParser
import pdb
#~ pdb.set_trace()


def run(dicoInfo,dicoCalc):
    '''Lancement de l'impression'''

    tmpdir = os.environ['NOTECALC_TMP']
    tmpfile = os.path.join(tmpdir,'print')
    fileconfig = os.path.join(os.environ['NOTECALC_CONFPLUGINSDIR'],'print.cfg')

    if not os.path.exists(fileconfig) :
        import gtk
        dialog = gtk.MessageDialog(
                    None, #parent
                    gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                    gtk.MESSAGE_WARNING, # type
                    gtk.BUTTONS_OK, # boutons
                    "Vous devez d'abord configurer le plugin d'impression."#Message
                )
        dialog.run()
        dialog.destroy()
        options()

    config = ConfigParser.ConfigParser()
    config.read(fileconfig)

    from imp import load_source
    pathplug = os.path.join(os.environ['NOTECALC_DIR'],"plugins","export_LaTeX",'main.py')
    #~ pdb.set_trace()
    try :
        os.unlink("%s.ps"%tmpfile)
    except :
        pass
    loadplugin = load_source('main',pathplug)
    LaTeXclass =  loadplugin.pluginLaTeX()
    fileTEX = LaTeXclass.createLaTeX(tmpfile, dicoInfo,dicoCalc)
    fileDVI = LaTeXclass.compilLaTeX(fileTEX)

    #converstion dvi ps
    cmd = '%s "%s"'%(config.get('PluginPrint','dvips'), fileDVI)
    print cmd
    os.system('"%s"'%cmd)

    #impression ps
    cmd = '%s "%s.ps"'%(config.get('PluginPrint','psviewer'), tmpfile)
    print cmd
    os.system(cmd)

    return True


class options() :
    def __init__ (self):
        import gtk, gtk.glade
        self.gui = gtk.glade.XML(os.path.join(os.path.dirname(__file__),"options.glade"))
        dictionnaire_temporaire = {}
        for iteration in dir(self.__class__):
            dictionnaire_temporaire[iteration]= getattr(self,iteration)
        self.gui.signal_autoconnect(dictionnaire_temporaire)

        #charge l'ancien fichier de config
        fileconfig = os.path.join(os.environ['NOTECALC_CONFPLUGINSDIR'],'print.cfg')
        self.config = ConfigParser.ConfigParser()
        self.config.read(fileconfig)

        try :
            self.gui.get_widget('dvips').set_text(self.config.get('pluginPrint', 'dvips'))
        except :
            if os.name=='nt' :
                self.gui.get_widget('dvips').set_text('"%s"'%os.path.join(os.environ['PROGRAMFILES'],'MiKTeX 2.7','miktex','bin','dvips.exe'))
            else :
                self.gui.get_widget('dvips').set_text('dvips')

        try :
            self.gui.get_widget('psviewer').set_text(self.config.get('pluginPrint', 'psviewer'))
        except :
            if os.name=='nt' :
                self.gui.get_widget('psviewer').set_text('PRINT')
            else :
                self.gui.get_widget('psviewer').set_text('gnome-open')

    def on_optionsPrint_close(self,arg) :
        print "on_optionsPrint_close"

    def on_optionsPrint_destroy_event(self,arg) :
        print "on_optionsPrint_destroy_event"

    def on_validButton_clicked(self,button):
        '''Quand ok est clicker, enregistrement dans un fichier ini'''
        try :
            self.config.add_section('PluginPrint')
        except :
            pass
        self.config.set('PluginPrint', 'dvips', self.gui.get_widget("dvips").get_text())
        self.config.set('PluginPrint', 'psviewer', self.gui.get_widget("psviewer").get_text())

        self.config.write(open(os.path.join(os.environ['NOTECALC_CONFPLUGINSDIR'],'print.cfg'),'w'))

        self.gui.get_widget('optionsPrint').destroy()


    def on_cancelButton_activate(self,button):
        '''bt_cancel'''
        self.gui.get_widget('optionsPrint').destroy()

if __name__ == '__main__':
    import gtk
    os.environ['NOTECALC_CONFPLUGINSDIR'] = os.path.dirname(__file__)
    options()
    gtk.main()
